<?php 

function jsdtab_create_tabhead ( & $arr_colnames, & $arr_headline, & $headline_more_txt, & $scrollx, & $compact ) {	
	// NOTE: all parameters above are in use as reference (read-only-operation on data)
	
	if ( jsdtab_arg_is_enabled( $scrollx ) ) { 
		$class_ext .= ' nowrap';   // RELATION: "nowrap"-class in html-tablehead belongs to "scrollX: true"-javascript-code
	}
	
	if ( jsdtab_arg_is_enabled( $compact ) ) { 
		$class_ext .= ' compact';   // reduce row-height in html-tables
	}
	
	// start html-table
	$html='
	<table id="table_id" class="display' . $class_ext . '" cellspacing="0" width="100%">
	<thead>
		<tr>';
			for($i=0; $i<count($arr_colnames); $i++) {
				// print text (heading in each column)
				if ( count($arr_headline)>0 ) {
					// txt for the headline is specified by shortcode: "head=HeadingText1,HeadingText2,HeadingText3"
					$html .= '<th>' . $arr_headline[$i] . '</th>';
				} else {
					// headline not specified by shortcode = resolve headline-txt from column names
					if ( $arr_colnames[$i] == 'more' ) {
						// columnname 'more' is a special keyword (show 'read more'-link, if keyname 'more' is found in 'cols')
						$html .= '<th>' . $headline_more_txt . '</th>';
					} else {
						// otherwise take txt from wp-build-in-translation: __('Title'), __('Published'), __('Author'), ... 
						// EXAMPLE: columnname => e.g. "title" => convert "title" to "Title" => run WP-Translate => __('Title')
						$html .= '<th>' . __(ucfirst( $arr_colnames[$i] )) . '</th>';
					}
				}
			}
	$html.= '
		</tr>
	</thead>
	<tbody>	';	
	
	return $html;
}


function jsdtab_create_tabrow ( & $arr_colnames, & $arr_linkto, & $linkto, & $ahrefclass, & $dateformat, & $more_txt, & $url_extension ) {
	// NOTE: all parameters above are in use as reference (read-only-operation on data) 

	// text in datatable as link?
	if ( !jsdtab_arg_is_disabled( $linkto ) ) { 
		
		// put css-class on link?
		if ( empty($ahrefclass) ) { 
			$A1 = '<td><a href="' . get_the_permalink() . '">'; // default (regular link to the post)
		} else {
			$A1 = '<td><a href="' . get_the_permalink() . $url_extension . '" class="' . $ahrefclass . '">'; 
		}
		$A2 = '</a></td>'; // define var
	} else {
		
	}
	
	// data in tablerow
	$html="\n	<tr>";
		for($i=0; $i<count($arr_colnames); $i++) {  // build all columns in the row
			switch ( $arr_colnames[$i] ) {
				
				 // wordpress contains more common "build in fields" on a post, but at this point the plugin
				 // only considers the treatment for this 3 post-fields: 'title', 'published' and 'author'. 
				 // That means, all other fields at this point will be interpreted as a "custom post field".
				 
				case "title":
					if ( in_array('title', $arr_linkto) ) { 
						$html .= $A1 . get_the_title() . $A2; 
					} else { 
						$html .= '<td>' . get_the_title() . '</td>'; 
					}
					break;
					
				case "published":
					if ( in_array('published', $arr_linkto) ) { 
						$html .= $A1 . get_the_date( $dateformat ) . $A2;
					} else {
						$html .= '<td>' . get_the_date( $dateformat ) . '</td>';
					}
					break;
					
				case "author":
					if ( in_array('author', $arr_linkto) ) { 
						$html .= $A1 . get_the_author() . $A2; 
					} else {
						$html .= '<td>' . get_the_author() . '</td>'; 
					}
					break;
					
				case "more":
					// columnname 'more' is a special keyword = deliver read-more-link, if keyname 'more' contains to 'cols'
					$html .= $A1 . $more_txt . $A2; 
					break;
					
				default:
					// pull data from a custom post field / e.g. fieldname "motorbike"
					if ( in_array( get_post_meta(get_the_ID(), $arr_colnames[$i], true), $arr_linkto ) ) {  
						$html .= $A1 . get_post_meta(get_the_ID(), $arr_colnames[$i], true) . $A2; 
					} else {
						$html .= '<td>' . get_post_meta(get_the_ID(), $arr_colnames[$i], true) . '</td>';
					}
					break;
			}
		}
	$html.= "</tr> ";
	
	return $html;
}


function jsdtab_create_tabbody () {
	
	$html='
	</tbody>
	</table> ';
	
	return $html;
}

?>