<?php

function jsdtab_print_inline_jsscript ( $arg, & $arr_colnames, & $arr_orderby, & $arr_order  ) {
	// setup and init "JsDataTable" --> create some inline js-script-code to run JsDataTable
	// NOTE A: $arg contains the shortcode-data
	// NOTE B: & $arr_colnames / & $arr_orderby / & $arr_order-parameters --> references (read-only-operation on data)
	
	define( 'NL', "\n" );
	define( 'NLTAB', "\n	" );
	
	$jsscript .= NL;
	$jsscript .= "<script type='text/javascript'>" 		. NL;
	$jsscript .= "jQuery(document).ready(function() { "	. NLTAB;
	$jsscript .= "	jQuery('#table_id').DataTable( { " 	. NL;
	
			// JAVASCRIPT: by default the js-libary handels following vars as 'true'
			if ( jsdtab_arg_is_disabled($arg['searching']) ) 	{ $jsscript .= "'searching':false,"; } 
			if ( jsdtab_arg_is_disabled($arg['ordering']) ) 	{ $jsscript .= "'ordering':false,"; } 
			if ( jsdtab_arg_is_disabled($arg['navinfo']) ) 		{ $jsscript .= "'navinfo':false,"; } 	
			
			// JAVASCRIPT: by default the js-libary handels following var as 'false'
			if ( jsdtab_arg_is_enabled($arg['scrollx']) ) 	{ $jsscript .= "'scrollX':true,"; } // RELATION: "scrollX: true"-javascript-code belongs to "nowrap"-css-class in html-tablehead
			
			// JAVASCRIPT: 'paging + dropdown-menu'
			if ( jsdtab_arg_is_disabled($arg['paging']) ) {
				$jsscript .= "'paging':false,";
			} else {
				$jsscript .= "'paging':true,";
				if ( jsdtab_arg_is_disabled($arg['dropdown']) ) {
					$jsscript .= "'lengthChange':false,";
				} else {
					$jsscript .= "'lengthChange':true,";
					// generate js-code with this syntax: " 'lengthMenu': [[10,25,50,-1], [10, 25, 50, 'All']], ""
					$jsscript .= "'lengthMenu':[[" . str_replace('all', '-1', $arg['dropdown']) . "],[" . str_replace('all', "'" . $arg['dropdown_all_txt'] . "'", $arg['dropdown']) . "]],";
				}
			}		
			
			// JAVASCRIPT: 'order'
			if ( !empty($arg['orderby']) ) {
				// generate js-code with this syntax: ' "order": [[3,"asc"],[1,"dsc"],[2,"asc"], '
				$jsscript .= "'order':[";
				for($i=0; $i < count($arr_orderby); $i++) {   						
					if ( array_search($arr_orderby[$i], $arr_colnames) ) {  // look for col_number
						$colnu = array_search($arr_orderby[$i], $arr_colnames);  // take col_numer if fieldname belongs to col_list
					} else {
						$colnu = 0;  // col_num 0 if invalid fieldname 
					}
					$valid_sorting = array("asc", "ASC", "dsc", "DSC");	
					if (in_array( $arr_order[$i], $valid_sorting )) {
						$jsscript .= "[" . $colnu . ",'" . $arr_order[$i] . "']";  // add next element
					} else {	
						$jsscript .= "[" . $colnu . ",'asc']";  // add next element (take 'asc' as a fallback)
					}
					if ( $i < count($arr_orderby)-1 ) { $jsscript .= ","; }  // add field seperator if more elements
				}
				$jsscript .= "],";			
			} 
			
			// JAVASCRIPT: 'highligh ordered columns with a light color'
			if ( jsdtab_arg_is_disabled($arg['sortingcolor']) ) {
				$jsscript .= " 'bSortClasses':false,"; // turn off color-highlighting for ordered columns (build-in-value is: true)
			} 
			
			// JAVASCRIPT: 'language' / 'en' is deep burned into mininified js-libary (no further include required if 'en')
			if ( !empty( $arg['lang'] ) ) {
				if ( file_exists( JSDATATABLE_ABSPATH . 'js/language.' . $arg['lang'] . '.dataTables.js' ) ) {
					$jsscript .= "'language': " . file_get_contents( JSDATATABLE_ABSPATH . 'js/language.' . $arg['lang'] . '.dataTables.js' );	
				}
			}
		
	$jsscript .= NLTAB . "} ); ";  // END jQuery('#table_id').DataTable( {
		
	// USE JQUERY: "turn off" color-highlighting for ordered cols when the webpage starts at first time (remove css_class)
	// (later: if a user explizit clicks on a column to order his data, it's fine when then the color-highlighting appears)
	if ( $arg['sortingcolorstartup'] == 'no' ) {   
		 if ( empty($arg['orderby']) ) {
			 // css_class 'sorting_1' is set on column #1 when page loads (if "ordering-feature" is active) => remove this...
			$jsscript .= NLTAB . "jQuery('table tr td:nth-child('+1+')').removeClass('sorting_1');"; 
		} else {
			// css_classes 'sorting_1', 'sorting_2',... are set on all ordered cols => remove this...
			for($num=1; $num <= count($orderby); $num++) {
				$jsscript .= NLTAB . "jQuery('table tr td').removeClass('sorting_" . $num . "');";
			}
		 }
	}

	$jsscript .= NL . "} ); ";  // END jQuery(document).ready(function() {
	$jsscript .= NL . "</script> \n\n";  // END <script type='text/javascript'>
	
	return $jsscript;
}

?>